/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package jp.hemohemo.testlistview2;

import javafx.scene.control.ListCell;
import javafx.scene.image.ImageView;
import javafx.scene.layout.HBox;
import javafx.scene.layout.Priority;
import javafx.scene.layout.VBox;
import javafx.scene.text.Font;
import javafx.scene.text.Text;

/**
 *
 * @author miyamoto
 */
public class ArticleCell extends ListCell<Article> {
    private final HBox hbox;
    private final ImageView imageView;
    private final VBox vbox;
    private final Text user;
    private final Text comment;
    
    public ArticleCell() {
        hbox = new HBox(5);
        imageView = new ImageView();
        imageView.setFitWidth(64);
        imageView.setFitHeight(64);
        
        vbox = new VBox(5);
        user = new Text();
        user.setFont(new Font("System Bold", 18));
        comment = new Text();
        VBox.setVgrow(user, Priority.NEVER);
        VBox.setVgrow(comment, Priority.ALWAYS);
        HBox.setHgrow(imageView, Priority.NEVER);
        HBox.setHgrow(vbox, Priority.ALWAYS);
        vbox.getChildren().addAll(user, comment);
        hbox.getChildren().addAll(imageView, vbox);
        // ユーザ名、コメントをVBoxの幅-5で折り返すようにバインドしとく
        user.wrappingWidthProperty().bind(vbox.widthProperty().subtract(5));
        comment.wrappingWidthProperty().bind(vbox.widthProperty().subtract(5));
    }

    @Override
    protected void updateItem(Article item, boolean empty) {
        super.updateItem(item, empty);
        
        if(empty) {
            setText(null);
            setGraphic(null);
        } else {
            imageView.setImage(item.getImage());
            user.setText(item.getUser());
            comment.setText(item.getComment());
            setGraphic(hbox);
        }
    }
    
}
